Skip to main content

Clean Rooms

View as Markdown

Create Clean Room Asset Review Beta

POST /api/2.0/clean-rooms/{clean_room_name}/assets/{asset_type}/{name}/reviews

Submit an asset review

API scopes: cleanrooms

Parameters

clean_room_namestringpath

Name of the clean room

namestringpath

Name of the asset

asset_typestringpath

Asset type. Can either be NOTEBOOK_FILE or JAR_ANALYSIS.

Values: ASSET_TYPE_UNSPECIFIED, TABLE, NOTEBOOK_FILE, VOLUME, VIEW, FOREIGN_TABLE, JAR_ANALYSIS

Request body

notebook_reviewobjectRequired
Show child attributesHide child attributes
etagstring

Etag identifying the notebook version

review_statestring

Review outcome

Values: NOTEBOOK_REVIEW_STATE_UNSPECIFIED, APPROVED, REJECTED, PENDING

commentstring

Review comment

Example: Code looks wrong

Constraints: <= 500 characters

jar_analysis_reviewobjectRequired
Show child attributesHide child attributes
etagstring

Etag identifying the jar analysis version, with its value being a hash of an internally-generated UUID

review_statestring

Review outcome

Values: JAR_ANALYSIS_REVIEW_STATE_UNSPECIFIED, APPROVED, REJECTED, PENDING

commentstring

Review comment

Example: Code looks wrong

Constraints: <= 500 characters

Response

notebook_reviewsarray of object

All existing notebook approvals or rejections

Show child attributesHide child attributes
reviewer_collaborator_aliasstring

Collaborator alias of the reviewer

created_at_millisint64

When the review was submitted, in epoch milliseconds

review_statestring

Review outcome

Values: NOTEBOOK_REVIEW_STATE_UNSPECIFIED, APPROVED, REJECTED, PENDING

commentstring

Review comment

Example: Code looks wrong

Constraints: <= 500 characters

review_sub_reasonstring

Specified when the review was not explicitly made by a user

Values: NOTEBOOK_REVIEW_SUB_REASON_UNSPECIFIED, BACKFILLED, AUTO_APPROVED

jar_analysis_reviewsarray of object

All existing jar analysis approvals or rejections

Show child attributesHide child attributes
reviewer_collaborator_aliasstringPublic Preview

collaborator alias of the reviewer

created_at_millisint64Public Preview

timestamp of when the review was submitted

review_statestringPublic Preview

review outcome

Values: JAR_ANALYSIS_REVIEW_STATE_UNSPECIFIED, APPROVED, REJECTED, PENDING

commentstringPublic Preview

review comment

Example: Not ready to run yet

Constraints: <= 500 characters

review_sub_reasonstringPublic Preview

specified when the review was not explicitly made by a user

Values: JAR_ANALYSIS_REVIEW_SUB_REASON_UNSPECIFIED, AUTO_APPROVED

notebook_review_statestringRequired

Top-level status derived from all reviews

Values: NOTEBOOK_REVIEW_STATE_UNSPECIFIED, APPROVED, REJECTED, PENDING

jar_analysis_review_statestringRequired

top-level status derived from all reviews

Values: JAR_ANALYSIS_REVIEW_STATE_UNSPECIFIED, APPROVED, REJECTED, PENDING

Create Clean Room Output Catalog GA

POST /api/2.0/clean-rooms/{clean_room_name}/output-catalogs

Create the output catalog of the clean room.

API scopes: cleanrooms

Parameters

clean_room_namestringpath

Name of the clean room.

Request body

output_catalogobject
Show child attributesHide child attributes
statusstring

Values: OUTPUT_CATALOG_STATUS_UNSPECIFIED, NOT_ELIGIBLE, NOT_CREATED, CREATED

catalog_namestring

The name of the output catalog in UC. It should follow UC securable naming requirements. The field will always exist if status is CREATED.

Response

output_catalogobject
Show child attributesHide child attributes
statusstring

Values: OUTPUT_CATALOG_STATUS_UNSPECIFIED, NOT_ELIGIBLE, NOT_CREATED, CREATED

catalog_namestring

The name of the output catalog in UC. It should follow UC securable naming requirements. The field will always exist if status is CREATED.

List Clean Room Notebook Task Runs GA

GET /api/2.0/clean-rooms/{clean_room_name}/runs

List all the historical notebook task runs in a clean room.

API scopes: cleanrooms

Parameters

clean_room_namestringpath

Name of the clean room.

notebook_namestringquery

Notebook name

page_sizeint32query

The maximum number of task runs to return. Currently ignored - all runs will be returned.

page_tokenstringquery

Opaque pagination token to go to next page based on previous query.

Response

runsarray of object

Name of the clean room.

Show child attributesHide child attributes
notebook_namestring

Asset name of the notebook executed in this task run.

start_timeint64

When the task run started, in epoch milliseconds.

run_durationint64

Duration of the task run, in milliseconds.

notebook_job_run_stateobject

State of the task run.

Show child attributesHide child attributes
life_cycle_statestring

A value indicating the run's current lifecycle state. This field is always available in the response. Note: Additional states might be introduced in future releases.

Values: RUN_LIFE_CYCLE_STATE_UNSPECIFIED, PENDING, RUNNING, TERMINATING, TERMINATED, SKIPPED, INTERNAL_ERROR, BLOCKED, WAITING_FOR_RETRY, QUEUED

result_statestring

A value indicating the run's result. This field is only available for terminal lifecycle states. Note: Additional states might be introduced in future releases.

Values: RUN_RESULT_STATE_UNSPECIFIED, SUCCESS, FAILED, TIMEDOUT, CANCELED, MAXIMUM_CONCURRENT_RUNS_REACHED, UPSTREAM_CANCELED, UPSTREAM_FAILED, EXCLUDED, EVICTED, SUCCESS_WITH_FAILURES, UPSTREAM_EVICTED, DISABLED

collaborator_job_run_infoobject

Job run info of the task in the runner's local workspace. This field is only included in the LIST API. if the task was run within the same workspace the API is being called. If the task run was in a different workspace under the same metastore, only the workspace_id is included.

Show child attributesHide child attributes
collaborator_job_idint64

Job ID of the task run in the collaborator's workspace.

collaborator_job_run_idint64

Job run ID of the task run in the collaborator's workspace.

collaborator_task_run_idint64

Task run ID of the task run in the collaborator's workspace.

collaborator_workspace_idint64

ID of the collaborator's workspace that triggered the task run.

collaborator_aliasstring

Alias of the collaborator that triggered the task run.

output_schema_namestring

Name of the output schema associated with the clean rooms notebook task run.

output_schema_expiration_timeint64

Expiration time of the output schema of the task run (if any), in epoch milliseconds.

notebook_etagstring

Etag of the notebook executed in this task run, used to identify the notebook version.

notebook_updated_atint64

The timestamp of when the notebook was last updated.

shared_output_schema_namestringPublic Preview

Name of the shared output schema associated with the clean rooms notebook task run. This schema is accessible by all collaborators when enable_shared_output is true.

shared_output_schema_expiration_timeint64Public Preview

Expiration time of the shared output schema of the task run (if any), in epoch milliseconds.

next_page_tokenstring

Opaque token to retrieve the next page of results. Absent if there are no more pages. page_token should be set to this value for the next request (for the next page of results).

List Clean Room Task Runs Handler GA

GET /api/2.0/clean-rooms/{clean_room_name}/task-runs

List all the historical task runs in a clean room.

API scopes: cleanrooms

Parameters

clean_room_namestringpath

Name of the clean room.

namestringquery

Executable name.

task_typestringquery

Filter by the type of Clean Room task.

Values: CLEAN_ROOM_TASK_TYPE_UNSPECIFIED, NOTEBOOK, JAR

page_sizeint32query

The maximum number of task runs to return. Maximum value of 100.

page_tokenstringquery

Opaque pagination token to go to next page based on previous query.

Response

runsarray of object

Task runs in the clean room.

Show child attributesHide child attributes
namestring

Name of the executable.

task_typestring

The type of Clean Room task.

Values: CLEAN_ROOM_TASK_TYPE_UNSPECIFIED, NOTEBOOK, JAR

start_timeint64

When the task run started, in epoch milliseconds.

run_durationint64

Duration of the task run, in milliseconds.

task_run_stateobject

State of the task run.

Show child attributesHide child attributes
life_cycle_statestring

A value indicating the run's current lifecycle state. This field is always available in the response. Note: Additional states might be introduced in future releases.

Values: RUN_LIFE_CYCLE_STATE_UNSPECIFIED, PENDING, RUNNING, TERMINATING, TERMINATED, SKIPPED, INTERNAL_ERROR, BLOCKED, WAITING_FOR_RETRY, QUEUED

result_statestring

A value indicating the run's result. This field is only available for terminal lifecycle states. Note: Additional states might be introduced in future releases.

Values: RUN_RESULT_STATE_UNSPECIFIED, SUCCESS, FAILED, TIMEDOUT, CANCELED, MAXIMUM_CONCURRENT_RUNS_REACHED, UPSTREAM_CANCELED, UPSTREAM_FAILED, EXCLUDED, EVICTED, SUCCESS_WITH_FAILURES, UPSTREAM_EVICTED, DISABLED

collaborator_job_run_infoobject

Job run info of the task in the runner's local workspace. This field is only included in the LIST API if the task was run within the same workspace the API is being called. If the task run was in a different workspace under the same metastore, only the workspace_id is included.

Show child attributesHide child attributes
collaborator_job_idint64

Job ID of the task run in the collaborator's workspace.

collaborator_job_run_idint64

Job run ID of the task run in the collaborator's workspace.

collaborator_task_run_idint64

Task run ID of the task run in the collaborator's workspace.

collaborator_workspace_idint64

ID of the collaborator's workspace that triggered the task run.

collaborator_aliasstring

Alias of the collaborator that triggered the task run.

output_infoobject

Information about run output

Show child attributesHide child attributes
output_schema_namestring

Name of the output schema associated with the clean room task run.

output_schema_expiration_timeint64

Expiration time of the output schema of the task run (if any), in epoch milliseconds.

analysis_detailsobject

Information about the analysis run (etag, updated at)

Show child attributesHide child attributes
etagstring

Etag of the asset executed in this task run, used to identify the asset version.

updated_atint64

The timestamp of when the asset was last updated.

shared_output_infoobjectPublic Preview

Information about shared output accessible by all collaborators. This field is only populated when enable_shared_output is true.

Show child attributesHide child attributes
output_schema_namestring

Name of the output schema associated with the clean room task run.

output_schema_expiration_timeint64

Expiration time of the output schema of the task run (if any), in epoch milliseconds.

next_page_tokenstring

Opaque token to retrieve the next page of results. Absent if there are no more pages. page_token should be set to this value for the next request (for the next page of results).